// except2.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <iostream.h>
#include <fstream.h>
#include <sys/stat.h>

// takes a path name an returns the filename 
// at the end
char * basename(char * path)
{
	char * lastslash, *base;
	lastslash = strrchr(path,'\\'); // find the last slash
	base = strdup(lastslash+1); // copy starting one char later
	return base;
} // basename

class noopen {};  // used to mark a missing file exception
class notsource {}; // used to throw an executable file exception

/* This tries to open the file passed in.
	If the file can't be opened, throw a noopen execption
	If it opens but it is an executable file, then throw the
	notsource exception
*/
void 
myopen(char * name)
{
   struct stat buf;
   ifstream joe;
   joe.open(name,ios::nocreate);
   if(!joe) {
      cerr << "couldn't open " << name << endl;
      throw noopen();
   }
   cout << "file " << name << " opened" << endl;

   // the stat() function sets the second argument to point
   // to a structure that contains information about the file
   if(stat(name,&buf) == 0) {  // if not zero, then the file check failed
      if(buf.st_mode & S_IEXEC) {
         cerr << "file executable" << endl;
         throw notsource();
      }
   }
   else
	   cerr << "file " << name << " not statable" << endl;
} // myopen


int 
main(int argc, char* argv[])
{
	 char name[256], fname2[265], *f2base;

	 (void) strcpy(name, "somefile");  // this should be a file that isn't there
	 (void) strcpy(fname2, argv[0]);  // make a copy of the program name

	 f2base = strdup(strtok(fname2,"."));  // get the part before the .exe

	 (void) sprintf(fname2,"%s.ilk",f2base); // make a new filename

	 cout << "first filename is " << name << endl;
	 cout << "second filename is " << fname2 << endl;

    // retry method 1: re-run function that failed
    try { myopen( name); } 
    catch (noopen foo) {
        cerr << "caught no open exception, try 1" << endl;
        myopen( fname2);
      }
    catch (...) {
       cerr << "some other error found" << endl;
    }

    cout << endl << "starting second test" << endl;
	// retry method 2: run in a forever loop until it works
    (void) strcpy(name,basename(argv[0]));  // start with the program name
    while(true) {
       try { myopen(name); } 
       catch (noopen foo) {
           cerr << "caught no open exception, try 2" << endl;
           break;
         }
       catch (notsource foo) {
		   cerr << "caught notsource exception" << endl;

		  (void) strcpy(fname2,  basename(argv[0]));
		   f2base = strdup(strtok(fname2,"."));
          (void) sprintf(name,"../%s.cc",f2base);
          continue;
       }
       break;
    } // while
	return 0;
}
