#include "stdafx.h"
#include <stdlib.h>
#include "dlists.h"

// remove the node that contains the data my_d
int
remove(List_data *&l, Data my_d)
{
   List_data *before,*current;
   if(l == NULL) return(-1);

   // if the first one is the one we want, delete it quick
   if( is_equal(l->d,my_d) ){
      before = l;
      l->prev = NULL;
      l = l->next;
      delete before;
      return 0;
   }

   // if we find it, make the one that comes before it
   // point to the one that comes after. This deletes the node
   // from the list. Then delete the memory it used.
   current = l;  
   while(current != NULL) {
      if( is_equal(current->d,my_d) ){ 
	 // make the one before the target point to the one after the
	 // target. And the one after should point to the one before
	 current->prev->next = current->next;
	 if(current->next != NULL)  // if there is one after
	    current->next->prev = current->prev;
         delete current;
         return(0);
      }
      current = current->next;
   } // while

   return -1;  // didn't find it
} // remove
