#include "stdafx.h"
#include <stdlib.h>
#include "dlists.h"

// remove the node that contains the data my_d
int
remove(List_data *&l, Data my_d)
{
   List_data *before,*current;
   if(l == NULL) return(-1);

   // if the first one is the one we want, delete it quick
   if( is_equal(l->d,my_d) ){
      l = l->next;
      return 0;
   }

   // set up two pointers. One (current) we walk along the list
   // looking for the data my_d.
   // the other points to the one that comes before it.
   before = l;  // we know already that the first one isn't it
   current = l->next;  // start with the second one

   // if we find it, make the one that comes before it
   // point to the one that comes after. This deletes the node
   // from the list. Then delete the memory it used.
   while(current != NULL) {
      if( is_equal(current->d,my_d) ){ 
         before->next = current->next;
         delete current;
         return(0);
      }
      // move the two pointers to the next nodes
      before = current;
      current = current->next;
   } // while

   return -1;  // didn't find it
} // remove
