// except.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <iostream.h>
#include <stdlib.h>
#include <string.h>

// sample data to try all tests
// This is an array of character arrays.
// Each element in the array is another array.
// Actually, each element is a pointer to a character array'
// The last one is NULL so we know when the end has come.
char *data[] = {"1","2","3",NULL};

// An empty class as an exception place holder
class error1 {}; 

// This exception class will carry a message from the place
// the error ocurred to the place it is handled.
class error2 {
   public:
      // default constructor uses 'No message' message
      error2() { mesg = new char[32]; (void) strcpy(mesg,"No message"); }
      error2( char *str) { 
         mesg = new char[strlen(str) + 1];  // make space for the message
         (void) strcpy(mesg,str); 
      }
      char * get_mesg() { return(mesg); }
   private:
      char *mesg;
};

// a set of small functions to generate exceptions
void
try1()
{
   cout << "starting try1" << endl;
   throw error1();
}

void
try2()
{
   cout << "starting try2" << endl;
   throw error2();
}

void
try3()
{
   cout << "starting try3" << endl;
   throw error2("error in try 3");
}

int 
main(int argc, char **argv)
{
   for(int i=0; data[i] != NULL; i++) {
       try {
              if(strcmp(data[i],"1") == 0) try1();
              if(strcmp(data[i],"2") == 0) try2();
              if(strcmp(data[i],"3") == 0) try3();
       } catch(error1 e1) {
              cout << "caught error1" << endl;
       }
       catch(error2 e2) {
              cout << "caught error2" << endl;
              cout << "mesg: " << e2.get_mesg() << endl;
       }
       cout << "----------------------------------" << endl;
   } // for
   return 0;
} // main
