// slists.cpp : a simple linked list using structures

#include "stdafx.h"
#include <conio.h>
#include <iostream>
using namespace std;
const int STRSIZE = 64;

// each instance of this struct represents one character in the string
struct cnode {
        char c;  // data for this node
        cnode * next;  // pointer to the next node
}; // cnode

// this reads in char by char, counting how many have been entered
// if the number exceeds the length passed in, the reading stops
// This assumes that the array pointed to by str is long enough
void
get_string(char * str,int length,char * prompt)
{
    char c, *ptr = str;
    cout << prompt << " (limit " << length << ") " << endl;
    while(true) {
        c = _getche();   //reads an echoes one character
        if(c == '\r') break; // user hit enter key
        *ptr++ = c;        
        if((ptr - str) > (length -1 )) {
                cout << " no more characters can be entered" << endl;
                break;
        }
    } //while read characters
    *ptr = '\0';
    putchar('\n'); //cout << endl;
} // get_string

// add a data element to the front of the list. Returns true if OK
bool
add_to_front(cnode * & front,char data)
{
    cnode * new_node;

    if( (new_node = new cnode) == NULL) {
        cerr << " no memory for cnode \n";
        return false;
    }
    new_node->c = data;
    new_node->next=front;
    front = new_node;
    return true;
} // add_to_front

// add a data element to the back of the list. Returns true if OK
bool
add_to_end(cnode * & front,char data)
{
    cnode * new_node;
    cnode * ptr = front;

    if( (new_node = new cnode) == NULL) {
        cerr << " no memory for cnode \n";
        return false;
    }
    new_node->c = data;
    new_node->next = NULL;

    //if the list is empty then the last is the first, so put it
    //on the front of the list
    if(front == NULL) {
            cout << "add first one" << endl;
            front = new_node;
            return true;
    }

    // if not, we have to find the last element in the list
    // The last element is the one whose next pointer is NULL
    while(ptr->next != NULL) ptr = ptr->next;
    // now ptr points to the last element in the list
    // so make it point to the new one
    ptr->next = new_node;
    return true;
} // add_to_end

// put the characters from the cstring into a list
void
strtolist(cnode *& front,char * source)
{
        char * ptr = source;
        while(*ptr) {
//                cout << "adding char " << (char) *ptr << endl;
                if(!add_to_end(front,*ptr)) {
                        cerr << "adding char " << (char) *ptr << "failed" << endl;
                        return;
                }
                ptr++;
        } // while
} // strtolist

// print the characters in the string list and a new line at the end
void
print_list(cnode * front)
{
        cnode *ptr = front;  // always copy the pointer
        if(front == NULL) return;   // nothing to print
        while(ptr != NULL) {
                cout << ptr->c;
                ptr = ptr->next;
        } // while
        cout << endl;
} // print_list

int 
main(int argc, char* argv[])
{
    return 0;
}
