/* tree.h - Class that represents a binary tree
 * Binary trees have at most two children per node
 * Includes a node structure.
 * */

#include <string>
using namespace std;

enum PRINT_TYPE{INORDER,POSTORDER,PREORDER};
const int MAXCOUNT = 20;  // max time a word can appear

class tree {
    public:
        tree() { root=NULL; debug=false;}
//        ~tree();
        bool add_value(string,int);    // add a new string value to the tree
        bool find(string);         // search for a string, return true or false
        void print();  // print the tree, inorder
        void treeprint();  // print the tree sideways
        bool remove(string);       // search for the string and delete the node
        bool remove2(string);      // alt search for the string and delete the node
	    void inserti(string);  // iterative insert
        void debugon() { debug = true;}
        void debugoff() { debug = false;}
        int countem();
        string mostcommon();
    private:
        struct node {
            string value;
			int count;
			int poslist[MAXCOUNT];
            node * left;
            node * right;
        };

        node * root;
        bool debug;

		void mostcommonr(node *t,node *& lots);

		int countemr(node *);
        bool add_valuer(node * & ,string, int,int);
        void printr(node *);
        void treeprintr(node *, int); 
        bool findr(node *, string); 
        bool remover(string,node *&);
        void del(node *&, node *);  // support function for remover2
        bool remover2(string,node *&);
        void del2(node *&, node *);  // support function for remover2
	    void insert2(node * &,string);
}; // tree
