// trees.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <iostream>
#include <fstream>
#include <string>
#include "tree.h"
#include "except.h"
using namespace std;
ostream Os(cout); // default is to use cout
bool ToScreen = true;

void goOn()
{
   	Os << "-------------------------------------" << endl;
	if(ToScreen) {
    	Os << "hit something to continue";
    	cin.ignore();
	}
} // goOn

int main(int argc, char* argv[])
{
    tree T;
    string str;
    ifstream filein;
    ofstream fileout;
	char where;
	int wordpos = 1;

	cout << "output to screen (S) or file(F) ";
	cin >> where;

	// default is to use cout so we only check for file choice
	if((where == 'F') || (where == 'f')) {
		fileout.open("treeout.txt");
		if(!fileout) {
			cerr << "Open of treeout.txt failed" << endl;
			exit(1);
		}
		Os = fileout;
		ToScreen = false;
	}

    filein.open("trees.txt");   // file to read test strings from
    if( ! filein) {
        Os << "Couldn't open the test data file" << endl;
        exit(1);
    }

    try {
		// load data from the file into the tree
        while(true) {
            filein >> str;
        	if(filein.eof()) break;   // real end of file
            T.add_value(str, wordpos++);
            Os << "After adding <" << str << ">" << endl;
        } // input file read
        filein.close();
    }
    catch(Err *e) {
        Os << "ERROR:" << *e << endl;
    }
    catch(Mem *m) {
        Os << "MEMORY:" << *m << endl;
    }

	T.print();
	// how many unique words
	Os << "There are " << T.countem() << " unique words in the list" << endl; 
	
	// most common word
	Os << "The most  common word was " << T.mostcommon() << endl; 

	goOn();
    return 0;
}
