// listhead - class that represents the list as a whole
#include "stdafx.h"
#include "listhead.h"
#include <string.h>

// have to destroy each one in the list
listhead::~listhead()
{
	node * ptr, *current;
	if(head == NULL)
		return;
	ptr = head;
	while(ptr != NULL) {
		current = ptr;
		ptr = ptr->get_next();
		delete current;
	} // while
} // listheader destructor

ostream& 
operator<<(ostream & os, listhead &lh)
{ 
   node * ptr=lh.head;
   int count = 0;
   os << "[";
   while(ptr != NULL) {
      if(count > 0) os << ",";
      os << ptr->get_data();
      count++;
      ptr = ptr->get_next();
   }
   os << "]";
   return os;
} // operator<<

// add a data element to the end of the list. Returns true if OK
bool
listhead::enqueue(char * nodedata)
{
	node * new_node;

	if( (new_node = new node) == NULL) {
		cerr << " no memory for node \n";
		return false;
	}
	new_node->set_data(nodedata);
	new_node->set_next(NULL);

	if(tail == NULL)
		head = tail = new_node;
	else
		tail->set_next(new_node);
	tail = new_node;
	return true;
} // add_to_end

// remove the first node  and return the string
char *
listhead::dequeue()
{
   node *temp;
   char * str;
   if(head == NULL) return NULL;
   temp = head;
   head = head->get_next();
   if(head == NULL) tail = NULL;
   if( (str = new char [ strlen(temp->get_data())+1]) == NULL) {
	cerr << " no memory for string \n";
	return NULL;
   }
   (void) strcpy(str,temp->get_data());
   delete temp;
   return str;
} // dequeue
