// listhead - class that represents the list as a whole
#include "stdafx.h"
#include <iostream>
#include "listhead.h"
using namespace std;

void
listhead::print()
{ 
   list<char>::iterator ptr=L.begin();
   int count = 0;
   cout << "[";
   while(ptr != L.end()) {
      if(count > 0) cout << ",";
      cout << *ptr;
      count++;
      ptr++;
   }
   cout << "]" << endl;
} // operator<<

ostream& 
operator<<(ostream & os, listhead &lh)
{ 
   copy(lh.L.begin(), lh.L.end(), ostream_iterator<char>(os,","));
   return os;
} // operator<<

// put the characters from the cstring into a list
void
listhead::strtolist(char * source)
{
        char * ptr = source;
        while(*ptr) {
            L.push_back(*ptr);
            ptr++;
        } // while
} // strtolist

// returns true if target is in the list and false otherwise
bool
listhead::isinlist(char target)
{
	if(find_element(target) != L.end())
		return true;
	return false;
} // isinlist

// search the list node by node until we find the one
// that contains my_d. Return NULL if we don't find it
list<char>::iterator 
listhead::find_element(char my_d)
{
    list<char>::iterator lptr = L.begin();
   while(lptr != L.end()) {
      if( *lptr == my_d ){
         return(lptr); // found it
      }
      lptr++;
   } // while
   return(L.end());
} // find_element

// search the list for the target char and add a new node after
// that one.
bool
listhead::add_after(char target,char my_d)
{
   list<char>::iterator lptr;
   
   // use the find_element() function above to locate target
   // in the list, if it is there
   lptr = find_element(target);
   if(lptr == L.end())  return(false); // not there
   // we are going to use a list method that adds before
   // the target. So we have to move one ahead.
   // But if that moves us to the end, then we use the 
   // list method to add to the end.
   if(++lptr == L.end()) {
	  L.push_back(my_d);
   }
   else {
   	 list<char> l;  // make a small list of the new data
	 l.push_front(my_d);
	 L.splice(lptr,l);  // puts the elements of l before lptr
   }
   return true;   
} // add_after

// search the list for the target char and add a new node before
// that one.
bool
listhead::add_before(char target,char my_d)
{
   list<char>::iterator lptr;
   
   // use the find_element() function above to locate target
   // in the list, if it is there
   lptr = find_element(target);
   if(lptr == L.end())  return(false); // not there
   L.insert(lptr,my_d);
   return true;   
} // add_before

// remove the node that contains the char my_d
bool
listhead::remove(char my_d)
{
		L.remove(my_d);
		return true;
} // remove
