// str3.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <iostream>
using namespace std;

const int STRLEN= 50;

int str_length(char * str);  // comes from the string library
//
// this reads in char by char, counting how many have been entered
// if the number exceeds the length passed in, the reading stops
// This assumes that the array pointed to by str is long enough
void
get_string(char * str,int length)
{
	char c, *ptr = str;
	while(true) {
		c = _getche();   //reads an echoes one character
		if(c == '\r') break; // user hit enter key
		*ptr++ = c;		
		if((ptr - str) > (length -1 )) {
				cout << " no more characters can be entered" << endl;
				break;
		}
	} //while read characters
	*ptr = '\0';
	putchar('\n'); //cout << endl;
} // get_string

//uses pointers to quickly and compactly copy strings
void
quick_copy(char * copy, char * instr)
{
   char *dest=copy, *src=instr;
   while(*dest++ = *src++) ; // all the work is in here
} // quick_copy

// do it again, showing the steps
void
quick_copy2(char * copy, char * instr)
{
   char *dest=copy,*src=instr;
   printf("Dest start value is [%d] src start address is [%d]\n",dest,src);
   while(*dest++ = *src++) {
      printf("copied src[%d](%c) to dest[%d](%c)\n",src-1,*(src-1),dest-1,*(dest-1));
   }
} // quick_copy2

// use pointers to print a cstring
void
print_string1(char * instr)
{
   char *ptr=instr;
   while(*ptr) putchar(*ptr++);
   putchar('\n');
} // print_string1

// use pointers in a do loop to print a cstring
void
print_string2(char * instr)
{
   char *ptr=instr;
   do {
      putchar(*ptr++);
   } while(*ptr);
   putchar('\n');
} // print_string2

void 
main(int argc, char **argv)
{
   char *instr,*copy;

   if((instr = new char[STRLEN]) == NULL) {
	   cout << "no space available" << endl;
	   exit(1);
   }
   cout << "enter a string to work on" << endl;
   get_string(instr,STRLEN);
   cout << "the input string was :" << instr << ":" << endl;

   // get enough space to hold the output string
   if((copy = new char[strlen(instr) + 1]) == NULL) {
	   cout << "no space available for copy" << endl;
	   exit(1);
   }

   quick_copy(copy,instr);
   cout << "the copy after the while is :" << copy << ":" << endl;

   // do it again, showing the steps
   quick_copy2(copy,instr);

   /* here is another way to do this, provided by a student, Doug.
      it doesn't require the copy pointers since it doesn't alter
	  the originals. Thus it uses somewhat less space.
	  Plus there is no chance of accidentally altering the original
   */
   for(  int x=0; (*(copy+x) = *(instr+x)) != '\0'; x++) ;
   cout << "the copy after the first for is :" << copy << ":" << endl;

   // or even
   for(  int y=0; (copy[y] = instr[y]) != '\0'; y++) ;
   cout << "the copy after the second for is :" << copy << ":" << endl;
       
   cout << "pointer loop printing" << endl;
   print_string1(instr);

   cout << "pointer do loop printing" << endl;
   print_string2(instr);
} // main
