// strlen.cpp : A collection of cstring length routines
//

#include "stdafx.h"
#include <iostream>
using namespace std;

const int STRSIZE = 64;  // size of input string buffer

// uses while loop to get length and
// array notation
int 
strlen1(char * str)
{
		int i = 0;
		while(str[i] != '\0') {
				i++;
		} // while
		return i;
} // strlen1

// uses while loop to get length and
// array notation
// Takes advantage of the integer definition of true/false
// and that chars can be ints. Also uses ++ in expression to
// update counter.
int 
strlen2(char * str)
{
		int i = 0;
		while(str[i++]) ;
		return i;
} // strlen2

// uses while loop to get length and
// pointer notation
// Takes advantage of the integer definition of true/false
// and that chars can be ints. Also uses ++ in expression to
// update counter.
int 
strlen3(char * str)
{
		int i = 0;
		while(*str++) i++;
		return i;
} // strlen3

// uses while loop to get length and
// array notation
int 
strlen4(char * str)
{
		int i = 0;
		for( ;str[i]; i++) ;
		return i;
} // strlen4

// uses pointers and arithmetic to get length
int 
strlen5(char * str)
{
		char * ptr = str;
		for( ;*ptr; ptr++) ;
		return ptr - str;
} // strlen5

// uses pointers and arithmetic to get length
int 
strlen6(char * str)
{
		char * ptr = str;
		while(*ptr++) ;
		return ptr - str;
} // strlen6

int main(int argc, char* argv[])
{
	char data[STRSIZE] = "This is a test";

	cout << "built-in length is : " << strlen(data) << endl;
	cout << "strlen1() length is : " << strlen1(data) << endl;
	cout << "strlen2() length is : " << strlen2(data) << endl;
	cout << "strlen3() length is : " << strlen3(data) << endl;
	cout << "strlen4() length is : " << strlen4(data) << endl;
	cout << "strlen5() length is : " << strlen5(data) << endl;
	cout << "strlen6() length is : " << strlen6(data) << endl;
	return 0;
}
