// trees.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <iostream>
#include <fstream>
#include <string>
#include "tree.h"
#include "except.h"
using namespace std;
ostream Os(cout); // default is to use cout
bool ToScreen = true;

void goOn()
{
   	Os << "-------------------------------------" << endl;
	if(ToScreen) {
    	Os << "hit something to continue";
    	cin.ignore();
	}
} // goOn

int main(int argc, char* argv[])
{
    tree T;
    string str;
    T.debugon();  // turn on extended output for  this tree
    ifstream filein;
    ofstream fileout;
	char where;

	cout << "output to screen (S) or file(F) ";
	cin >> where;

	// default is to use cout so we only check for file choice
	if((where == 'F') || (where == 'f')) {
		fileout.open("treeout.txt");
		if(!fileout) {
			cerr << "Open of treeout.txt failed" << endl;
			exit(1);
		}
		Os = fileout;
		ToScreen = false;
	}

    filein.open("trees.txt");   // file to read test strings from
    if( ! filein) {
        Os << "Couldn't open the test data file" << endl;
        exit(1);
    }

    try {
		// load data from the file into the tree
        while(true) {
            filein >> str;
        	if(filein.eof()) break;   // real end of file
            T.add_value(str);
            Os << "After adding <" << str << ">" << endl;
        } // input file read
        filein.close();
    }
    catch(Err *e) {
        Os << "ERROR:" << *e << endl;
    }
    catch(Mem *m) {
        Os << "MEMORY:" << *m << endl;
    }

    // in order print
	Os << "\n-----------------------------" << endl;
    T.inprint();
	goOn();  // wait to continue if using the screen

    // print the tree sideways
	Os << "\tprint the tree sideways to show the structure" << endl;
    T.treeprint();
	goOn();  // wait to continue if using the screen

    // search for the word 'color'
	Os << "\tsearch the tree for the word 'color'" << endl;
    if(T.find("color"))
        Os << "Word (color) was found" << endl;
    else
        Os << "Word (color) was not found" << endl;
	goOn();  // wait to continue if using the screen

    // search for the word 'kent'
	Os << "\tsearch the tree for the word 'kent'" << endl;
    if(T.find("kent"))
        Os << "Word (kent) was found" << endl;
    else
        Os << "Word (kent) was not found" << endl;

    try {
	goOn();  // wait to continue if using the screen

    // search for the word ''
	Os << "\tsearch the tree for the word ''(nothing)" << endl;
    if(T.find(""))
        Os << "Word () was found" << endl;
    else
        Os << "Word () was not found" << endl;
    }
    catch(Err *e) {
        Os << "ERROR:" << *e << endl;
    }
	goOn();  // wait to continue if using the screen

    // delete the word dog
	Os << "\tremove the word 'dog'" << endl;
    if(T.remove("dog"))
        Os << "Word (dog) was deleted" << endl;
    else
        Os << "Word (dog) was not deleted" << endl;
    T.treeprint();
	goOn();  // wait to continue if using the screen

    // add back  the word dog
	Os << "\tadd back the word 'dog'" << endl;
    T.inserti("dog");
    T.treeprint();
	goOn();  // wait to continue if using the screen

    // delete the word cut using the alternate remove
    Os << "\tdelete the word 'cut' using the alternate remove" << endl;
    if(T.remove2("cut"))
        Os << "Word (cut) was deleted" << endl;
    else
        Os << "Word (cut) was not deleted" << endl;
    T.treeprint();
	goOn();  // wait to continue if using the screen

    // add back the word cut
	Os << "\tadd back the word 'cut'" << endl;
    T.inserti("cut");
    T.treeprint();
	goOn();  // wait to continue if using the screen

    Os << "In order print" << endl;
    T.inprint();
	goOn();  // wait to continue if using the screen

    Os << "pre order print" << endl;
    T.preprint();
	goOn();  // wait to continue if using the screen

    Os << "post order print" << endl;
    T.postprint();

    return 0;
}
