#include <stdio.h>
#include <stream.h>
#include <stdlib.h>
#include <string.h>

class foo {
    public:    // first we do all  the public interface methods
    // these are used to put values in the private data elements
    void set_a(int x) { a=x;}
    void set_b(int x) { b=x;}
    void set_title(char *);

    // these are used to get the values from the private data elements
    int get_a() { return(a);}
    int get_b() { return(b);}

    // these are the constructors
    foo() { a = 0; b = 0; title = NULL;}   // default constructor
    foo(int x) { a=x; b = 0; title = NULL; }
    foo(int x,int y) { a= x; b = y; title=NULL;}
    // notice that one constructor can call another
    // and  they can call other methods
    foo(int x,int y,char * str) : a(x),b(y) { set_title(str);}

    // these are defined outside the class declaration
    int bigger(); 
    void print_title();

    /* there is only one destructor. Note that the only
       way for title to be non-null is if we set the title
       so we should delete the space we created
    */
    ~foo() { cout << "the destructor is running" << endl; 
             if(title != NULL) delete [] title;}
    private:  // these are private data, not visible outside the class
    int a,b;
    char *title;
    // private methods can only be called by other class methods
    void set_length() { a = strlen(title);}
}; // class foo

int
foo::bigger()
{
   if(a < b) return(b);
   return(a);
} // bigger

void
foo::set_title(char * str)
{
   // note the use of cerr to print the error to stderr
   if( (title = new char[strlen(str)+1]) == NULL) {
      cerr << "no memory for to save title :" << str << ":" << endl;
      return;
   }
   (void) strcpy(title,str);
   set_length();
} // set_title

void
foo::print_title()
{
   if(title != NULL)
      cout << title << endl;
   else
      cout << "NULL" << endl;
} // print_title

int 
main(int argc, char **argv)
{
   foo X,Y(6),Z(7,8),W(1,2,"hello");

   printf("X.a = %d X.b = %d ",X.get_a(),X.get_b());
   X.print_title();
   printf("Y.a = %d Y.b = %d ",Y.get_a(),Y.get_b());
   Y.print_title();
   printf("Z.a = %d Z.b = %d ",Z.get_a(),Z.get_b());
   Z.print_title();
   printf("W.a = %d W.b = %d ",W.get_a(),W.get_b());
   W.print_title();
   /* here is what I get when I run this with g++
    
X.a = 0. X.b = 0 NULL
Y.a = 6. Y.b = 0 NULL
Z.a = 7. Z.b = 8 NULL
W.a = 5. W.b = 2 hello
the destructor is running
the destructor is running
the destructor is running
the destructor is running

*/
 
   /* the following statements are illegal
      remove the comment markers and see what your compiler does
      with them
   */
//    X.a = 5;
//    cout << "a = " << X.a << endl;
//    X.set_length();

/* here are the errors that g++ gives me
class.cc: In function `int main(int, char **)':
class.cc:100: member `a' is a private member of class `foo'
class.cc:101: member `a' is a private member of class `foo'
class.cc:39: `void foo::set_length()' is private
class.cc:102: within this context

*/
} // main
